Imports System
Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Common.Globals

Namespace EfficionConsulting.Categories

    Public MustInherit Class EditCategory
        Inherits PortalModuleBase

        Public CategoryID As Integer = -1

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            If Not (Request.Params("CategoryId") Is Nothing) Then
                CategoryID = Integer.Parse(Request.Params("CategoryId"))
            End If

            If Not IsPostBack Then
                Dim Categories As New CategoryController
                SetIconControlProperties()
                PopulateParentList(Categories)

                If CategoryID <> -1 Then
                    Dim objCategory As CategoryInfo = Categories.GetCategory(CategoryID)
                    txtCategoryName.Text = objCategory.CategoryName.ToString
                    txtAbbreviation.Text = objCategory.Abbreviation.ToString
                    If Not cboParentCategory.Items.FindByValue(objCategory.ParentCategoryId.ToString) Is Nothing Then
                        cboParentCategory.Items.FindByValue(objCategory.ParentCategoryId.ToString).Selected = True
                    End If

                    ctlIcon.Url = objCategory.IconFile

                    cmdDeleteCategory.Visible = True
                Else 'New Category
                    cmdDeleteCategory.Visible = False
                End If
            End If
        End Sub

        Private Sub SetIconControlProperties()
            ctlIcon.ShowFiles = True
            ctlIcon.ShowTabs = False
            ctlIcon.ShowUrls = False
            ctlIcon.Required = False

            ctlIcon.ShowLog = False
            ctlIcon.ShowNewWindow = False
            ctlIcon.ShowTrack = False
            ctlIcon.FileFilter = glbImageFileTypes

        End Sub

        Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
            Response.Redirect(NavigateURL(), True)
        End Sub

        Private Sub cmdUpdateCategory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdUpdateCategory.Click
            Dim Categories As New CategoryController
            Dim objCat As New CategoryInfo
            Dim strIcon As String = ""
            strIcon = ctlIcon.Url

            objCat.CategoryId = CategoryID
            objCat.PortalId = PortalId
            objCat.CategoryName = txtCategoryName.Text
            objCat.Abbreviation = txtAbbreviation.Text
            objCat.ParentCategoryId = Int32.Parse(cboParentCategory.SelectedValue)
            objCat.IconFile = strIcon

            If CategoryID = -1 Then
                Categories.AddCategory(objCat)
            Else
                Categories.UpdateCategory(objCat)
            End If

            Response.Redirect(NavigateURL(), True)
        End Sub

        Private Sub cmdDeleteCategory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDeleteCategory.Click
            Dim Categories As New CategoryController
            Categories.DeleteCategory(CategoryID)
            Response.Redirect(NavigateURL(), True)
        End Sub

        Private Sub PopulateParentList(ByRef objCC As CategoryController)
            cboParentCategory.DataSource = objCC.GetParentCategories(PortalId)
            cboParentCategory.DataTextField = "CategoryName"
            cboParentCategory.DataValueField = "CategoryID"
            cboParentCategory.DataBind()
            cboParentCategory.Items.Insert(0, New System.Web.UI.WebControls.ListItem("<None Specified>", "-1"))
            'Remove Self
            If Not CategoryID = -1 Then
                cboParentCategory.Items.Remove(cboParentCategory.Items.FindByValue(CategoryID))
            End If

        End Sub
    End Class
End Namespace
